<template>
  
  <b-card header="Pesquise um equipamento" style="margin-top: 1.5em;">
    <b-form-input
      v-model="form.search_term"
      placeholder="Digite a pesquisa"
      @input="searchLazy"/>
    <b-btn v-b-toggle.collapse1 variant="primary" @click="filtering=!filtering; searchLazy();">Filtros</b-btn>
    <b-collapse id="collapse1" class="mt-2">
      <b-form-checkbox-group id="checkboxesFilterGroup" v-model="search_filters" plain name="Filters">
        <b-form-checkbox value="equipment_name" class="w-100 mx-md-5">Nome do equipamento</b-form-checkbox>
        <b-form-checkbox value="equipment_english_name" class="w-100 mx-md-5">Nome do equipamento em inglês</b-form-checkbox>
        <b-form-checkbox value="equipment_presentation" class="w-100 mx-md-5">Apresentação</b-form-checkbox>
        <b-form-checkbox value="equipment_brand" class="w-100 mx-md-5">Marca</b-form-checkbox>
        <b-form-checkbox value="equipment_model" class="w-100 mx-md-5">Modelo</b-form-checkbox>
        <b-form-checkbox value="equipment_patrimony_number" class="w-100 mx-md-5">Numero de patrimonio</b-form-checkbox>
        <b-form-checkbox value="equipment_description" class="w-100 mx-md-5">Descrição</b-form-checkbox>
        <b-form-checkbox value="equipment_offered_services" class="w-100 mx-md-5">Serviços oferecidos</b-form-checkbox>
        <b-form-checkbox value="central_name" class="w-100 mx-md-5">Nome da central</b-form-checkbox>
        <b-form-checkbox value="unit_name" class="w-100 mx-md-5">Nome da unidade</b-form-checkbox>
      </b-form-checkbox-group>
    </b-collapse>
    <div v-for="search_response in search_responses" :key="search_response.equipment_name">
      <b-card @click="onClickEquipment(search_response.id)">
        <p><b>{{ search_response.equipment_name }}</b></p>
        <p>{{ search_response.presentation }}</p>
    </b-card></div>

</b-card></template>

<script>
const searchDelay = 500;

export default {
  data() {
    return {
      filtering: false,
      search_filters: [],
      testing: true,
      searching: false,
      form: {
        search_term: "",
        equipment_name: true,
        equipment_english_name: true,
        equipment_presentation: true,
        equipment_brand: true,
        equipment_model: true,
        equipment_patrimony_number: true,
        equipment_researcher_name: true,
        equipment_description: true,
        equipment_offered_services: true,
        central_name: true,
        unit_name: true
      },
      typing_timer: false,
      search_responses: []
    };
  },

  watch: {
    filtering() {
      this.search();
    },
    search_filters() {
      if (this.filtering) this.search();
    }
  },

  methods: {
    async searchLazy() {
      clearTimeout(this.typingTimer);
      if (this.query !== "") {
        this.typingTimer = setTimeout(this.search, searchDelay);
      }
    },

    onClickEquipment(id) {
      console.log(id);
      this.$router.push("/equipamento/" + id);
    },

    async search() {
      try {
        if (this.form.search_term !== "") {
          if (this.filtering == true) {
            this.form.equipment_name = this.search_filters.includes(
              "equipment_name"
            )
              ? true
              : false;
            this.form.equipment_english_name = this.search_filters.includes(
              "equipment_english_name"
            )
              ? true
              : false;
            this.form.equipment_presentation = this.search_filters.includes(
              "equipment_presentation"
            )
              ? true
              : false;
            this.form.equipment_brand = this.search_filters.includes(
              "equipment_brand"
            )
              ? true
              : false;
            this.form.equipment_model = this.search_filters.includes(
              "equipment_model"
            )
              ? true
              : false;
            this.form.equipment_patrimony_number = this.search_filters.includes(
              "equipment_patrimony_number"
            )
              ? true
              : false;
            this.form.equipment_researcher_name = this.search_filters.includes(
              "equipment_researcher_name"
            )
              ? true
              : false;
            this.form.equipment_description = this.search_filters.includes(
              "equipment_description"
            )
              ? true
              : false;
            this.form.central_name = this.search_filters.includes(
              "central_name"
            )
              ? true
              : false;
            this.form.unit_name = this.search_filters.includes("unit_name")
              ? true
              : false;
          } else {
            this.search_filters = [];
            this.form.equipment_name = this.form.equipment_english_name = this.form.equipment_brand = this.form.equipment_presentation = this.form.equipment_model = this.form.equipment_patrimony_number = this.form.equipment_researcher_name = this.form.equipment_description = this.form.central_name = this.form.unit_name = true;
          }
          const result = await this.$axios.$post(
            "search/equipments",
            this.form
          );
          this.search_responses = result.equipments;
        }
      } catch (e) {
        console.log(e);
      }
    }
  }
};
</script>
